#include "com_myproject_MylibJni.h"
#include <stdio.h>
#include <windows.h>
#include <signal.h>


JNIEnv *cur_env;       /* pointer to native method interface */


void calljvm() {
	JavaVM *jvm;

	(*cur_env)->GetJavaVM(cur_env, &jvm);
	(*jvm)->AttachCurrentThread(jvm, (void **)(&cur_env), &cur_env);
	jclass cls = (*cur_env)->FindClass(cur_env, "com/myproject/MylibJni");
	jmethodID mid = (*cur_env)->GetStaticMethodID(cur_env, cls, "wmEndsession", "()V");
	(*cur_env)->CallStaticVoidMethod(cur_env, cls, mid);

	(*jvm)->DetachCurrentThread(jvm);
}


LRESULT CALLBACK WndProc(HWND hwnd, UINT   msg, WPARAM wParam,LPARAM lParam)
{
	switch(msg) {
		case WM_ENDSESSION :
			calljvm();
		break;
		default:
		break;
	}

    return DefWindowProc(hwnd, msg, wParam, lParam);
}


void registerWndProc() {
    HINSTANCE h2 = GetModuleHandle(NULL);

    static char szAppName[] = "winhello";

    WNDCLASSEX  wndclass;

    wndclass.cbSize         = sizeof(wndclass);
    wndclass.style          = CS_HREDRAW | CS_VREDRAW;
    wndclass.lpfnWndProc    = WndProc;
    wndclass.cbClsExtra     = 0;
    wndclass.cbWndExtra     = 0;
    wndclass.hInstance      = h2;
    wndclass.hIcon          = LoadIcon(NULL, IDI_APPLICATION);
    wndclass.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);
    wndclass.hCursor        = LoadCursor(NULL, IDC_ARROW);
    wndclass.hbrBackground  = (HBRUSH) GetStockObject(WHITE_BRUSH);
    wndclass.lpszClassName  = szAppName;
    wndclass.lpszMenuName   = NULL;


    /*  Register a new window class with Windows  */
    if (!RegisterClassEx(&wndclass)) {
    	MessageBox(NULL, TEXT("Registering class failed!"), TEXT("Error!"), MB_ICONEXCLAMATION | MB_OK);
    	return;
    }


    /*  Create a window based on our new class  */
    HWND hwnd;

    hwnd = CreateWindow(szAppName, "Hello, world!",
			WS_OVERLAPPEDWINDOW,
			CW_USEDEFAULT, CW_USEDEFAULT,
			CW_USEDEFAULT, CW_USEDEFAULT,
			NULL, NULL, h2, NULL);


    // CraeteWindow failed?
    if( !hwnd ) {
    	MessageBox(NULL, TEXT("Window creation failed!"), TEXT("Error!"), MB_ICONEXCLAMATION | MB_OK);
    	return;
    }


    /*  Show and update our window  */
    ShowWindow(hwnd, 0);		// 0 = SW_HIDE
    UpdateWindow(hwnd);

    MSG msg;
	while (GetMessage(&msg, NULL, 0, 0) ) {
    	TranslateMessage(&msg);    /*  for certain keyboard messages  */
    	DispatchMessage(&msg);     /*  send message to WndProc        */
	}
}


JNIEXPORT void JNICALL Java_com_myproject_MylibJni_listenMessages(JNIEnv *env, jclass clazz) {
	cur_env = env;

	// Creates window & enters message loop
    registerWndProc();
}

