package com.myproject;

import java.awt.MenuItem;
import java.awt.PopupMenu;
import java.awt.SystemTray;
import java.awt.TrayIcon;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.imageio.ImageIO;
import javax.swing.JFrame;

public class MainGUI extends JFrame {
	
	private static final long serialVersionUID = 1L;


	public MainGUI() {
		super();
		
		init();
	}
	
	public void init() {
		// do nothing on close window (can reopened by double clicking the icon in the SystemTray)
		setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
		
		// set some properties
		setTitle("My project");
		setSize(200, 400);
	}
	
	
	public static void main(String[] args) {
		
		// instantiate JFrame
		MainGUI g = new MainGUI();
		g.setVisible(true);
		
		// call DLL function
		MylibJni.listenMessagesWrapper();

		
		// add SystemTray icon
		try {
			// PopupMenu to close
			PopupMenu m = new PopupMenu();
			MenuItem mi = new MenuItem("Close");
			mi.addActionListener(new ActionListener() {
				@Override
				public void actionPerformed(ActionEvent evt) {
					System.exit(0);
				}
			});
			m.add(mi);
			
			// add tray icon
			TrayIcon ti = new TrayIcon(ImageIO.read(MainGUI.class.getResource("/com/myproject/resources/testicon.png")));
			ti.setPopupMenu(m);
			SystemTray.getSystemTray().add(ti);
			
			// handle double click tray icon
			ti.addActionListener(new ActionListener() {
				@Override
				public void actionPerformed(ActionEvent evt) {
					g.setVisible(true);
				}
			});
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
}
