package com.myproject;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Date;

public class MylibJni {
	public static native void listenMessages();
	
	/**
	 * wrapper for listenMessages, to auto load the .dll-file & call listenMessage() in
	 * a thread. It's necessary to run it in a Thread, because the DLL creates a Window
	 * and enters a message loop
	 * 
	 */
	public static void listenMessagesWrapper() {
		System.load("C:/projects/jniblog/workspace/mylib/Debug/libmylib.dll");
		
		Thread t = new Thread(new Runnable() {
			public void run() {
				listenMessages();
			}
		});
		
		t.start();
	}
	
	
	/**
	 * called from mylib.dll when WM_ENDSESSION is received
	 * 
	 */
	public static void wmEndsession() throws IOException {
		File f = new File("C:/tmp/WmEndsession.txt");
		f.createNewFile();
		
		PrintWriter pw = new PrintWriter(f);
		pw.println("WmEndsession called! - " + new Date());
		pw.close();
		
	}
	
}
